/**
 * 
 */
package ch.hslu.swk.g03.logger.server;

import static org.junit.Assert.*;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * @author Felix
 * 
 */
public class ServerTCPTest {

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
    }

    /**
     * @throws java.lang.Exception
     */
    @After
    public void tearDown() throws Exception {
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#getInstance()}.
     */
    @Test
    public void testGetInstance() {
	assertNotNull(ServerTCP.getInstance());
    }
    
    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#run()}.
     * @throws IOException 
     * @throws UnknownHostException 
     */
    @Test
    public void testRun() throws UnknownHostException, IOException {
	// init TCP-Server
	ServerTCP myServerTCP = ServerTCP.getInstance();
	myServerTCP.setPort(10321);
	myServerTCP.start();
	
	while (myServerTCP.isServerStarting()) {
	    try {
		Thread.sleep(100);
	    } catch (InterruptedException e) {
		System.err.println("[WARNING:Main] sleepinterrupt");
	    }
	}

	if (!myServerTCP.isServerListening()) {
	    fail("couldn't start ServerTCP!");
	}

	// simulate client
	Socket socket = new Socket("127.0.0.1",10321);
	socket.close();
	
	myServerTCP.stopServer();
    }    

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#setPort(int)}.
     */
    @Test
    public void testSetGetPort() {
	int newPort = 10321;
	ServerTCP.getInstance().setPort(newPort);
	assertEquals(newPort, ServerTCP.getInstance().getPort());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#addListeningClient(ch.hslu.swk.g03.logger.server.ServerTCPConnThread)}
     * .
     */
    @Test
    public void testAddListeningClient() {
	ServerTCPConnThread myClient = new ServerTCPConnThread(ServerTCP.getInstance(), new Socket());
	ServerTCP.getInstance().addListeningClient(myClient);
	// no possible way to verify
	assertTrue(true);
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#removeListeningClient(ch.hslu.swk.g03.logger.server.ServerTCPConnThread)}
     * .
     */
    @Test
    public void testRemoveListeningClient() {
	ServerTCPConnThread myClient = new ServerTCPConnThread(ServerTCP.getInstance(), new Socket());
	ServerTCP.getInstance().addListeningClient(myClient);
	ServerTCP.getInstance().removeListeningClient(myClient);
	// no possible way to verify
	assertTrue(true);
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#numberOfConnectedClients()}
     * .
     */
    @Test
    public void testNumberOfConnectedClients() {
	ServerTCP myTCP = ServerTCP.getInstance();
	assertNotNull(myTCP.numberOfConnectedClients());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.ServerTCP#printConnectedClients()}.
     */
    @Test
    public void testPrintConnectedClients() {
	ServerTCP.getInstance().printConnectedClients();
	// no possible way to verify
	assertTrue(true);
    }

}
