package ch.hslu.swk.g03.logger.viewer;

/**
 * Viewer TestClass
 */

import java.util.ArrayList;
import java.util.Date;

import ch.hslu.loggerinterface.Loglevel;
import ch.hslu.swk.g03.logger.common.LogMessage;
import ch.hslu.swk.g03.logger.viewer.Loggergui;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 *
 */
public class LocalViewerTescht {
	Loggergui gui;

	/**
	 * SetUp Test Viewer
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		gui = new Loggergui();
	}

	/**
	 * TearDown Test Viewer
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		gui = null;
	}
	
	/**
	 * Instantiate GUI.
	 */
	@Test
	public void testGUI() {
		Loggergui.main(null);
	}
	
	/**
	 * Instantiate GUI and show it.
	 */
	@Test
	public void testGUI2() {
		Loggergui.main(null);
		Loggergui.createAndShowGUI(); //NO GUI on buildserver
	}
	
	/**
	 * Add Message to GUI.
	 */
	@Test
	public void testGUIaddMessage() {
		Loggergui.main(null);
		Loggergui.createAndShowGUI();
		LogMessage mess = new LogMessage();
		mess.setComputer("localhost");
		mess.setLoglevel(Loglevel.INFO);
		mess.setSource("localhost");
		mess.setTimestamp(new Date());
		mess.setMessage("testing gui");
		Loggergui.addMessage(mess);
	}
	
	/**
	 * Add two Messages to GUI.
	 */
	@Test
	public void testGUIaddMessage2() {
		Loggergui.main(null);
		Loggergui.createAndShowGUI();
		LogMessage mess = new LogMessage();
		mess.setComputer("localhost");
		mess.setLoglevel(Loglevel.INFO);
		mess.setSource("localhost");
		mess.setTimestamp(new Date());
		mess.setMessage("testing gui");
		ArrayList<LogMessage> liste = new ArrayList<LogMessage>();
		liste.add(mess);
		LogMessage mess2 = mess;
		mess2.setMessage("testing gui second message");
		liste.add(mess2);
		Loggergui.addMessage(liste);
	}

}
